# -*- coding: utf-8 -*-

import os
import sys
from PySide import QtGui
from PySide import QtUiTools
from PySide import QtCore
from FreeCAD import Base
import FreeCAD, Part, math
import DraftVecUtils
import Sketcher
import PartDesign
from math import pi
import Draft
import FreeCAD, FreeCADGui
import FreeCAD as App
from shpst_data import ShpstData
from shpst_data import ParamAngle
from shpst_data import ParamChannel
from shpst_data import ParamHShape
from shpst_data import ParamIShape
from shpst_data import ParamCtShape
from shpst_data import ParamPipeShape
from shpst_data import ParamFlatShape
from shpst_data import ParamLWAngle
from shpst_data import ParamLWChannel
from shpst_data import ParamRipChannel
from shpst_data import ParamSqurePipe

#JIS G 3192


class Ui_Dialog(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("Dialog")
        Dialog.resize(300, 265)
        Dialog.move(1000, 0)
        #タイプ
        self.label_type = QtGui.QLabel(Dialog)
        self.label_type.setGeometry(QtCore.QRect(10, 10, 70, 12))
        self.label_type.setObjectName("label_type")
        self.comboBox_type = QtGui.QComboBox(Dialog)
        self.comboBox_type.setGeometry(QtCore.QRect(100, 10, 160, 22))
        self.comboBox_type.setObjectName("comboBox_type")
        #規格
        self.label_st = QtGui.QLabel(Dialog)
        self.label_st.setGeometry(QtCore.QRect(10, 35, 50, 12))
        self.label_st.setObjectName("label_st")
        self.comboBox_st = QtGui.QComboBox(Dialog)
        self.comboBox_st.setGeometry(QtCore.QRect(100, 35, 160, 22))
        self.comboBox_st.setObjectName("comboBox_st")
        #サイズ
        self.label_size = QtGui.QLabel(Dialog)
        self.label_size.setGeometry(QtCore.QRect(10, 60, 50, 12))
        self.label_size.setObjectName("label_size")
        self.comboBox_size = QtGui.QComboBox(Dialog)
        self.comboBox_size.setGeometry(QtCore.QRect(100, 60, 160, 22))
        self.comboBox_size.setObjectName("comboBox_size")
        #実行
        self.pushButton = QtGui.QPushButton(Dialog)
        self.pushButton.setGeometry(QtCore.QRect(200, 84, 61, 22))
        self.pushButton.setObjectName("pushButton")
        #長さ
        self.label_l = QtGui.QLabel(Dialog)
        self.label_l.setGeometry(QtCore.QRect(10, 85, 81, 20))
        #self.label_l.setAlignment(QtCore.Qt.AlignCenter)
        self.label_l.setObjectName("label_l")
        self.lineEdit_l = QtGui.QLineEdit(Dialog)
        self.lineEdit_l.setGeometry(QtCore.QRect(100, 85, 71, 20))
        self.lineEdit_l.setAlignment(QtCore.Qt.AlignCenter)
        self.lineEdit_l.setObjectName("lineEdit_l")
        
        #checkbox
        self.checkbox = QtGui.QCheckBox(Dialog)
        self.checkbox.setGeometry(QtCore.QRect(100, 110, 61, 23))
        self.checkbox.setObjectName("checkbox")
        self.checkbox.setChecked(True)
        
        #img
        self.label_img = QtGui.QLabel(Dialog)
        self.label_img.setGeometry(QtCore.QRect(0, 135, 300, 100))
        self.label_img.setText("")
        self.label_img.setAlignment(QtCore.Qt.AlignCenter)
        L=10
        self.lineEdit_l.setText(QtGui.QApplication.translate("Dialog", str(L), None))
        self.retranslateUi(Dialog)
        self.comboBox_type.addItems(ShpstData.type)
        self.comboBox_type.setCurrentIndex(1)
        self.comboBox_type.currentIndexChanged[int].connect(self.onType)
        self.comboBox_type.currentIndexChanged[int].connect(self.on_lst2)
        self.comboBox_type.setCurrentIndex(0)
        self.comboBox_st.setCurrentIndex(1)
        self.comboBox_st.currentIndexChanged[int].connect(self.onStandard)
        self.comboBox_st.setCurrentIndex(0)
        QtCore.QObject.connect(self.pushButton, QtCore.SIGNAL("pressed()"), self.create)
        QtCore.QMetaObject.connectSlotsByName(Dialog)

    def retranslateUi(self, Dialog):
        Dialog.setWindowTitle(QtGui.QApplication.translate("Dialog", "JIS G 3192 Shaped Steel", None))
        self.label_type.setText(QtGui.QApplication.translate("Dialog", "Shaped Steel", None))
        self.label_st.setText(QtGui.QApplication.translate("Dialog", "Standard", None))
        self.label_size.setText(QtGui.QApplication.translate("Dialog", "Size", None))
        self.label_l.setText(QtGui.QApplication.translate("Dialog", "Length[mm]", None))
        self.pushButton.setText(QtGui.QApplication.translate("Dialog", "Create", None))
        self.checkbox.setText(QtGui.QApplication.translate("Dialog", "Solid", None))
    def on_lst2(self):#管長
        pass

    def onType(self):
        global ta
        global key

        key = self.comboBox_type.currentText()[:2]
        if key=='00':
            ta=ShpstData.Angle_st
        elif key=='01':
            ta=ShpstData.Channel_st
        elif key=='02':
            ta=ShpstData.H_st
        elif key=='03':
            ta=ShpstData.I_st
        elif key=='04':
            ta=ShpstData.CT_st
        elif key=='05':
            ta=ShpstData.Pipe_st
        elif key=='06':
            ta=ShpstData.Flat_Bar_st
        elif key=='07':
            ta=ShpstData.LW_angle_st
        elif key=='08':
            ta=ShpstData.LW_channel_st
        elif key=='09':
            ta=ShpstData.Rip_channel_st
        elif key=='10':
            ta=ShpstData.Square_pipe_st

        self.comboBox_st.clear()
        self.comboBox_st.addItems(ta)

    def onStandard(self):
        global size
        global pic
        key = self.comboBox_type.currentText()[:2]
        st=self.comboBox_st.currentText()
        #print(st)
        if key=='00':
            pic='angle'
            if st=='SS_Equal':
                size=ShpstData.angle_ss_size
            elif st=='SS_Unequal':
                size=ShpstData.angle_ssun_size
            elif st=='SUS_Equal':
                size=ShpstData.angle_sus_size

        elif key=='01':
            pic='channel'
            if st=='SS':
                size=ShpstData.channel_ss_size
            elif st=='SUS':
                size=ShpstData.channel_sus_size
        elif key=='02':
            pic='h1_shape'
            if st=='SS_Wide':
                size=ShpstData.H_ss_w_size
                pic='h1_shape'
            elif st=='SS_Medium':
                pic='h2_shape'
                size=ShpstData.H_ss_m_size
            elif st=='SS_Thin':
                pic='h3_shape'
                size=ShpstData.H_ss_t_size
            elif st=='SUS':
                pic='h3_shape'
                size=ShpstData.H_sus_size
        elif key=='03':
            pic='i_shape'
            if st=='SS':
                size=ShpstData.I_ss_size
        elif key=='04':
            pic='ct_shape'
            if st=='SS':
                size=ShpstData.CT_ss_size
        elif key=='05':
            pic='pipe'
            if st=='STK':
                size=ShpstData.STK_ss_size
            elif st=='SUS_Sch20S':
                size=ShpstData.tube_d
            elif st=='SUS_Sch40':
                size=ShpstData.tube_d
        elif key=='06':
            pic='flat_bar'
            if st=='SS':
                size=ShpstData.Flat_bar_ss_size
            elif st=='SUS':
                size=ShpstData.Flat_bar_sus_size
        elif key=='07':
            pic='lw_angle'
            if st=='SS':
                size=ShpstData.LW_angle_ss_size
            elif st=='SUS':
                size=ShpstData.LW_angle_sus_size
        elif key=='08':
            pic='lw_channel'
            if st=='SS':
                size=ShpstData.LW_channel_ss_size
            elif st=='SUS':
                size=ShpstData.LW_channel_sus_size
        elif key=='09':
            pic='rip_channel'
            if st=='SS':
                size=ShpstData.Rip_channel_ss_size
            elif st=='SUS':
                size=ShpstData.Rip_channel_sus_size
        elif key=='10':
            pic='square_pipe'
            if st=='SS':
                size=ShpstData.Square_pipe_ss_size
            elif st=='SUS':
                size=ShpstData.Square_pipe_sus_size

        pic0='img_' + pic + '.png'
        base=os.path.dirname(os.path.abspath(__file__))
        joined_path = os.path.join(base, "shpst_data",pic0)
        self.label_img.setPixmap(QtGui.QPixmap(joined_path))
        self.comboBox_size.clear()
        self.comboBox_size.addItems(size)
        #print(size)

    def create(self):
        
        '''
        
        def angle(self):
            global c00
            obj.addProperty("App::PropertyFloat", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
        
        def channel(self):
            global c00
            obj.addProperty("App::PropertyFloat", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

        def h_shape(self):
            global c00
            H=float(sa[0])
            B=float(sa[1])
            t1=float(sa[2])
            t2=float(sa[3])
            r=float(sa[4])

            obj.addProperty("App::PropertyFloat", "H",label).H=H
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            obj.addProperty("App::PropertyFloat", "t1",label).t1=t1
            obj.addProperty("App::PropertyFloat", "t2",label).t2=t2
            obj.addProperty("App::PropertyFloat", "r",label).r=r
            #obj.addProperty("App::PropertyStringList", "key",label).key=key
            #obj.addProperty("App::PropertyStringList", "st",label).st=st

            x2=t1+2*r
            x1=(B-x2)/2
            y1=t2+r
            y2=(H-2*y1)
            x4=r/math.sqrt(2)
            x5=r*(1-1/math.sqrt(2))
            p1=(0,0,0)
            p2=(0,0,t2)
            p3=(x1,0,t2)
            p4=(x1+x4,0,t2+x5)
            p5=(x1+r,0,y1)
            p6=(x1+r,0,H-y1)
            p7=(x1+x4,0,H-(t2+x5))
            p8=(x1,0,H-t2)
            p9=(0,0,H-t2)
            p10=(0,0,H)
            p11=(B,0,H)
            p12=(B,0,H-t2)
            p13=(B-x1,0,H-t2)
            p14=(B-(x1+x4),0,H-(t2+x5))
            p15=(B-(x1+r),0,H-y1)
            p16=(B-(x1+r),0,y1)
            p17=(B-(x1+x4),0,y1-x4)
            p18=(B-x1,0,t2)
            p19=(B,0,t2)
            p20=(B,0,0)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.makeLine(p2,p3)
            edge3=Part.Arc(Base.Vector(p3),Base.Vector(p4),Base.Vector(p5)).toShape()
            edge4=Part.makeLine(p5,p6)
            edge5=Part.Arc(Base.Vector(p6),Base.Vector(p7),Base.Vector(p8)).toShape()
            edge6=Part.makeLine(p8,p9)
            edge7=Part.makeLine(p9,p10)
            edge8=Part.makeLine(p10,p11)
            edge9=Part.makeLine(p11,p12)
            edge10=Part.makeLine(p12,p13)
            edge11=Part.Arc(Base.Vector(p13),Base.Vector(p14),Base.Vector(p15)).toShape()
            edge12=Part.makeLine(p15,p16)

            edge13=Part.Arc(Base.Vector(p16),Base.Vector(p17),Base.Vector(p18)).toShape()
            edge14=Part.makeLine(p18,p19)
            edge15=Part.makeLine(p19,p20)
            edge16=Part.makeLine(p20,p1)
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9,edge10,edge11,edge12,edge13,edge14,edge15,edge16])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False 

        def i_shape(self):
            global c00
            H=float(sa[0])
            B=float(sa[1])
            t1=float(sa[2])
            t2=float(sa[3])
            r1=float(sa[4])
            r2=float(sa[5])
            
            obj.addProperty("App::PropertyFloat", "H",label).H=H
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            obj.addProperty("App::PropertyFloat", "t1",label).t1=t1
            obj.addProperty("App::PropertyFloat", "t2",label).t2=t2
            obj.addProperty("App::PropertyFloat", "r1",label).r1=r1
            obj.addProperty("App::PropertyFloat", "r2",label).r2=r2
            #obj.addProperty("App::PropertyStringList", "key",label).key=key
            #obj.addProperty("App::PropertyStringList", "st",label).st=st
            
            x1=(B-t1)/2
            x2=x1/2
            s45=math.radians(45)
            s8=math.radians(8)
            x3=r2*math.cos(s45)
            x31=r1*math.cos(s45)
            x4=r2-x3
            x5=r1*math.cos(s45)
            x6=r1-x31
            y4=r2*math.sin(s8)
            x8=r1*math.sin(s8)
            x30=r2-y4
            x9=x1+t1+r1-x8
            x10=x1+t1+x6
            x7=x2-x31
            y3=x7*math.tan(s8)
            y6=t2-(r2+y3)
            y5=r2*math.cos(s8)
            x11=x1-(x30+r1-x8)
            x12=x11*math.tan(s8)
            y9=r1*math.cos(s8)
            y1=y6+r2+x12+y9
            y2=H-2*y1
            y8=y6+y5+x12
            p1=(0,0,0)
            p2=(0,0,y6)
            p3=(x4,0,y6+x3)
            p4=(x30,0,y6+y5)
            p5=(x1-r1+x8,0,y8)
            p6=(x1-x6,0,y1-x31)
            p7=(x1,0,y1)
            p8=(x1,0,y1+y2)
            p9=(x1-x6,0,y1+y2+x31)
            p10=(x1-r1+x8,0,H-y8)
            p11=(x30,0,H-(y6+y5))
            p12=(x4,0,H-(y6+x3))
            p13=(0,0,H-y6)
            p14=(0,0,H)
            p15=(B,0,H)
            p16=(B,0,H-y6)
            p17=(B-x4,0,H-(y6+x3))
            p18=(B-x30,0,H-(y6+y5))
            p19=(x9,0,H-y8)
            p20=(x10,0,y1+y2+x31)
            p21=(x1+t1,0,y1+y2)
            p22=(x1+t1,0,y1)
            p23=(x10,0,y1-x31)
            p24=(x9,0,y8)
            p25=(B-x30,0,y6+y5)
            p26=(B-x4,0,y6+x3)
            p27=(B,0,y6)
            p28=(B,0,0)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.Arc(Base.Vector(p2),Base.Vector(p3),Base.Vector(p4)).toShape()
            edge3=Part.makeLine(p4,p5)
            edge4=Part.Arc(Base.Vector(p5),Base.Vector(p6),Base.Vector(p7)).toShape()
            edge5=Part.makeLine(p7,p8)
            edge6=Part.Arc(Base.Vector(p8),Base.Vector(p9),Base.Vector(p10)).toShape()
            edge7=Part.makeLine(p10,p11)
            edge8=Part.Arc(Base.Vector(p11),Base.Vector(p12),Base.Vector(p13)).toShape()
            edge9=Part.makeLine(p13,p14)
            edge10=Part.makeLine(p14,p15)
            edge11=Part.makeLine(p15,p16)
            edge12=Part.Arc(Base.Vector(p16),Base.Vector(p17),Base.Vector(p18)).toShape()
            edge13=Part.makeLine(p18,p19)
            edge14=Part.Arc(Base.Vector(p19),Base.Vector(p20),Base.Vector(p21)).toShape()
            edge15=Part.makeLine(p21,p22)
            edge16=Part.Arc(Base.Vector(p22),Base.Vector(p23),Base.Vector(p24)).toShape()
            edge17=Part.makeLine(p24,p25)
            edge18=Part.Arc(Base.Vector(p25),Base.Vector(p26),Base.Vector(p27)).toShape()
            edge19=Part.makeLine(p27,p28)
            edge20=Part.makeLine(p28,p1)
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9,edge10,edge11,edge12,edge13,edge14,edge15,edge16,edge17,edge18,edge19,edge20])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def ct_shape(self):
            global c00
            A=float(sa[0])
            B=float(sa[1])
            t1=float(sa[2])
            t2=float(sa[3])
            r=float(sa[4])
            obj.addProperty("App::PropertyFloat", "A",label).A=A
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            obj.addProperty("App::PropertyFloat", "t1",label).t1=t1
            obj.addProperty("App::PropertyFloat", "t2",label).t2=t2
            obj.addProperty("App::PropertyFloat", "r",label).r=r
            #obj.addProperty("App::PropertyStringList", "key",label).key=key
            #obj.addProperty("App::PropertyStringList", "st",label).st=st
            s45=math.radians(45)
            x1=r*math.cos(s45)
            x2=r-x1
            x3=t2+r
            x4=A-x3
            x5=(B-t1)/2
            p1=(0,0,0)
            p2=(0,0,A-x3)
            p3=(-x2,0,A-x3+x1)
            p4=(-r,0,A-t2)
            p5=(-x5,0,A-t2)
            p6=(-x5,0,A)
            p7=(t1+x5,0,A)
            p8=(t1+x5,0,A-t2)
            p9=(t1+r,0,A-t2)
            p10=(t1+x2,0,A-(t2+x2))
            p11=(t1,0,A-x3)
            p12=(t1,0,0)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.Arc(Base.Vector(p2),Base.Vector(p3),Base.Vector(p4)).toShape()
            edge3=Part.makeLine(p4,p5)
            edge4=Part.makeLine(p5,p6)
            edge5=Part.makeLine(p6,p7)
            edge6=Part.makeLine(p7,p8)
            edge7=Part.makeLine(p8,p9)
            edge8=Part.Arc(Base.Vector(p9),Base.Vector(p10),Base.Vector(p11)).toShape()
            edge9=Part.makeLine(p11,p12)
            edge10=Part.makeLine(p12,p1)
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9,edge10])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def pipe_shape(self):
            global c00
            if st=='STK':
                D=float(sa[0])
                t=float(sa[1])
                #self.label_type.setText(QtGui.QApplication.translate("Dialog", str(D),None ))    
            elif st=='SUS_Sch20S':
                D=float(sa[0])
                t=float(sa[8])
            elif st=='SUS_Sch40':
                D=float(sa[0])
                t=float(sa[9])
            obj.addProperty("App::PropertyFloat", "D",label).D=D  
            obj.addProperty("App::PropertyFloat", "t",label).t=t  
            #obj.addProperty("App::PropertyStringList", "key",label).key=key
            #obj.addProperty("App::PropertyStringList", "st",label).st=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c1 = Part.makeCylinder(D/2,L,Base.Vector(0,0,0),Base.Vector(0,1,0))
                #c2 = Part.makeCylinder((D-2*t)/2,L,Base.Vector(0,0,0),Base.Vector(0,1,0))
                #c00=c1.cut(c2)
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:
                #c1 = Part.makeCircle(D/2,Base.Vector(0,0,0),Base.Vector(0,1,0))
                #c2 = Part.makeCircle((D-2*t)/2,Base.Vector(0,0,0),Base.Vector(0,1,0))    
                #c00=c1.fuse(c2)
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False

        def flat_shape(self):
            global c00
            t=float(sa[0])
            B=float(sa[1])
            obj.addProperty("App::PropertyFloat", "t",label).t=t  
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            #obj.addProperty("App::PropertyStringList", "key",label).key=key
            #obj.addProperty("App::PropertyStringList", "st",label).st=st 
            p1=(0,0,0)
            p2=(0,0,t)
            p3=(B,0,t)
            p4=(B,0,0)
            awire=Part.makePolygon([p1,p2,p3,p4,p1])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",'Flat_shape').L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def LW_angle(self):
            global c00
            A=float(sa[0])
            B=float(sa[1])
            t=float(sa[2])
            obj.addProperty("App::PropertyFloat", "A",label).A=A
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            obj.addProperty("App::PropertyFloat", "t",label).t=t 
            r1=t
            r2=2*t
            x1=r1/math.sqrt(2)
            x2=r1-x1
            x3=r2/math.sqrt(2)
            x4=r2-x3
            p1=(0,0,r2)
            p2=(0,0,A)
            p3=(t,0,A)
            p4=(t,0,r2)
            p5=(t+x2,0,t+x2)
            p6=(r2,0,t)
            p7=(B,0,t)
            p8=(B,0,0)
            p9=(r2,0,0)
            p10=(x4,0,x4)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.makeLine(p2,p3)
            edge3=Part.makeLine(p3,p4)
            edge4=Part.Arc(Base.Vector(p4),Base.Vector(p5),Base.Vector(p6)).toShape()
            edge5=Part.makeLine(p6,p7)
            edge6=Part.makeLine(p7,p8)
            edge7=Part.makeLine(p8,p9)
            edge8=Part.Arc(Base.Vector(p9),Base.Vector(p10),Base.Vector(p1)).toShape()
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def LW_channel(self):
            global c00
            H=float(sa[0])
            B=float(sa[1])
            t=float(sa[2])
            obj.addProperty("App::PropertyFloat", "H",label).H=H
            obj.addProperty("App::PropertyFloat", "B",label).B=B
            obj.addProperty("App::PropertyFloat", "t",label).t=t 
            r2=2*t
            x1=t/math.sqrt(2)
            x2=t-x1
            x3=r2/math.sqrt(2)
            x4=r2-x3

            p1=(0,0,r2)
            p2=(0,0,H-r2)
            p3=(x4,0,H-x4)
            p4=(r2,0,H)
            p5=(B,0,H)
            p6=(B,0,H-t)
            p7=(r2,0,H-t)
            p8=(t+x2,0,H-(t+x2))
            p9=(t,0,H-r2)
            p10=(t,0,r2)
            p11=(t+x2,0,t+x2)
            p12=(r2,0,t)
            p13=(B,0,t)
            p14=(B,0,0)
            p15=(r2,0,0)
            p16=(x4,0,x4)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.Arc(Base.Vector(p2),Base.Vector(p3),Base.Vector(p4)).toShape()
            edge3=Part.makeLine(p4,p5)
            edge4=Part.makeLine(p5,p6)
            edge5=Part.makeLine(p6,p7)
            edge6=Part.Arc(Base.Vector(p7),Base.Vector(p8),Base.Vector(p9)).toShape()
            edge7=Part.makeLine(p9,p10)
            edge8=Part.Arc(Base.Vector(p10),Base.Vector(p11),Base.Vector(p12)).toShape()
            edge9=Part.makeLine(p12,p13)
            edge10=Part.makeLine(p13,p14)
            edge11=Part.makeLine(p14,p15)
            edge12=Part.Arc(Base.Vector(p15),Base.Vector(p16),Base.Vector(p1)).toShape()
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9,edge10,edge11,edge12])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def Rip_channel(self):
            global c00
            H=float(sa[0])
            A=float(sa[1])
            C=float(sa[2])
            t=float(sa[3])
            obj.addProperty("App::PropertyFloat", "H",label).H=H
            obj.addProperty("App::PropertyFloat", "A",label).A=A
            obj.addProperty("App::PropertyFloat", "C",label).C=C
            obj.addProperty("App::PropertyFloat", "t",label).t=t 
            r2=2*t
            x1=t/math.sqrt(2)
            x2=t-x1
            x3=r2/math.sqrt(2)
            x4=r2-x3

            p1=(0,0,r2)
            p2=(0,0,H-r2)
            p3=(x4,0,H-x4)
            p4=(r2,0,H)
            p5=(A-r2,0,H)
            p6=(A-x4,0,H-x4)
            p7=(A,0,H-r2)
            p8=(A,0,H-C)
            p9=(A-t,0,H-C)
            p10=(A-t,0,H-r2)
            p11=(A-(t+x2),0,H-(t+x2))
            p12=(A-r2,0,H-t)
            p13=(r2,0,H-t)
            p14=(t+x2,0,H-(t+x2))
            p15=(t,0,H-r2)
            p16=(t,0,r2)
            p17=(t+x2,0,t+x2)
            p18=(r2,0,t)
            p19=(A-r2,0,t)
            p20=(A-t,0,r2)
            p21=(A-t,0,C)
            p22=(A,0,C)
            p23=(A,0,r2)
            p24=(A-x4,0,x4)
            p25=(A-r2,0,0)
            p26=(r2,0,0)
            p27=(x4,0,x4)
            p28=(A-(t+x2),0,t+x2)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.Arc(Base.Vector(p2),Base.Vector(p3),Base.Vector(p4)).toShape()
            edge3=Part.makeLine(p4,p5)
            edge4=Part.Arc(Base.Vector(p5),Base.Vector(p6),Base.Vector(p7)).toShape()
            edge5=Part.makeLine(p7,p8)
            edge6=Part.makeLine(p8,p9)
            edge7=Part.makeLine(p9,p10)
            edge8=Part.Arc(Base.Vector(p10),Base.Vector(p11),Base.Vector(p12)).toShape()
            edge9=Part.makeLine(p12,p13)
            edge10=Part.Arc(Base.Vector(p13),Base.Vector(p14),Base.Vector(p15)).toShape()
            edge11=Part.makeLine(p15,p16)
            edge12=Part.Arc(Base.Vector(p16),Base.Vector(p17),Base.Vector(p18)).toShape()
            edge13=Part.makeLine(p18,p19)
            edge14=Part.Arc(Base.Vector(p19),Base.Vector(p28),Base.Vector(p20)).toShape()
            edge15=Part.makeLine(p20,p21)
            edge16=Part.makeLine(p21,p22)
            edge17=Part.makeLine(p22,p23)
            edge18=Part.Arc(Base.Vector(p23),Base.Vector(p24),Base.Vector(p25)).toShape()
            edge19=Part.makeLine(p25,p26)
            edge20=Part.Arc(Base.Vector(p26),Base.Vector(p27),Base.Vector(p1)).toShape()
            awire=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9,edge10,edge11,edge12,edge13,edge14,edge15,edge16,edge17,edge18,edge19,edge20])
            pface=Part.Face(awire)
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyFloat", "L",label).L=L
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "IsChecked",label).IsChecked = False
        def Square_pipe(self):
            global c00
            H=float(sa[0])
            A=float(sa[1])
            t=float(sa[2])
            obj.addProperty("App::PropertyFloat", "H",label).H=H
            obj.addProperty("App::PropertyFloat", "A",label).A=A
            obj.addProperty("App::PropertyFloat", "t",label).t=t 
            r2=2*t
            x1=t/math.sqrt(2)
            x2=t-x1
            x3=r2/math.sqrt(2)
            x4=r2-x3
            p1=(0,0,r2)
            p2=(0,0,H-r2)
            p3=(x4,0,H-x4)
            p4=(r2,0,H)
            p5=(A-r2,0,H)
            p6=(A-x4,0,H-x4)
            p7=(A,0,H-r2)
            p10=(A-t,0,H-r2)
            p11=(A-(t+x2),0,H-(t+x2))
            p12=(A-r2,0,H-t)
            p13=(r2,0,H-t)
            p14=(t+x2,0,H-(t+x2))
            p15=(t,0,H-r2)
            p16=(t,0,r2)
            p17=(t+x2,0,t+x2)
            p18=(r2,0,t)
            p19=(A-r2,0,t)
            p20=(A-t,0,r2)
            p23=(A,0,r2)
            p24=(A-x4,0,x4)
            p25=(A-r2,0,0)
            p26=(r2,0,0)
            p27=(x4,0,x4)
            p28=(A-(t+x2),0,t+x2)
            edge1=Part.makeLine(p1,p2)
            edge2=Part.Arc(Base.Vector(p2),Base.Vector(p3),Base.Vector(p4)).toShape()
            edge3=Part.makeLine(p4,p5)
            edge4=Part.Arc(Base.Vector(p5),Base.Vector(p6),Base.Vector(p7)).toShape()
            edge5=Part.makeLine(p7,p23)
            edge6=Part.Arc(Base.Vector(p23),Base.Vector(p24),Base.Vector(p25)).toShape()
            edge7=Part.makeLine(p25,p26)
            edge8=Part.Arc(Base.Vector(p26),Base.Vector(p27),Base.Vector(p1)).toShape()
            edge9=Part.makeLine(p1,p2)
            edge10=Part.Arc(Base.Vector(p15),Base.Vector(p14),Base.Vector(p13)).toShape()
            edge11=Part.makeLine(p13,p12)
            edge12=Part.Arc(Base.Vector(p12),Base.Vector(p11),Base.Vector(p10)).toShape()
            edge13=Part.makeLine(p10,p20)
            edge14=Part.Arc(Base.Vector(p20),Base.Vector(p28),Base.Vector(p19)).toShape()
            edge15=Part.makeLine(p19,p18)
            edge16=Part.Arc(Base.Vector(p18),Base.Vector(p17),Base.Vector(p16)).toShape()
            edge17=Part.makeLine(p16,p15)
            awire1=Part.Wire([edge1,edge2,edge3,edge4,edge5,edge6,edge7,edge8,edge9])
            awire2=Part.Wire([edge10,edge11,edge12,edge13,edge14,edge15,edge16,edge17])
            awire=awire1.fuse(awire2)
            #Part.show(aWire)
            pface1=Part.Face(awire1)
            pface2=Part.Face(awire2)
            pface=pface1.cut(pface2)
            obj.addProperty("App::PropertyFloat", "L",label).L=L
            if self.checkbox.isChecked():
                
                #c00=pface.extrude(Base.Vector(0,L,0))
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                #c00=pface
                #obj.Shape=c00
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False
        '''
        #def imput():
        key = self.comboBox_type.currentText()[:2]
        L=self.lineEdit_l.text()
        #obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
        
        if key=='00':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='Angle'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='L'
            try:
                if st=='SS_Equal' or st==['SS_Equal']:
                    sa=ShpstData.angle_ss_equal[dia]
                elif st=='SS_Unequal':
                    sa=ShpstData.angle_ss_unequal[dia]
                elif st=='SUS_Equal':
                    sa=ShpstData.angle_sus_equal[dia]
            except:
                pass

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
        
            ParamAngle.Angle(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 
        elif key=='01':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='Channel'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='C'
            if st=='SS':
                sa=ShpstData.channel_ss[dia]
            elif st=='SUS':
                sa=ShpstData.channel_sus[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
            ParamChannel.Channel(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='02':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='HShape_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='H'+st
            if st=='SS_Wide':
                sa=ShpstData.H_ss_w[dia]
            elif st=='SS_Medium':
                sa=ShpstData.H_ss_m[dia]
            elif st=='SS_Thin':
                sa=ShpstData.H_ss_t[dia]
            elif st=='SUS':
                sa=ShpstData.H_sus[dia]
            
            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
            ParamHShape.HShape(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='03':
            #global sa
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='IShape_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            #obj.addProperty("App::PropertyStringList", "dia",label).dia=dia
            b='I'
            if st=='SS':
                sa=ShpstData.I_ss[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

            ParamIShape.IShape(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='04':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='CTShape_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='CT'
            if st=='SS':
                sa=ShpstData.CT_ss[dia]
            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
            
            ParamCtShape.CtShape(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='05':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='Pipe_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='Pipe'
            if st=='STK':
                sa=ShpstData.STK_ss[dia]
            elif st=='SUS_Sch20S':
                sa=ShpstData.tubes[dia]
            elif st=='SUS_Sch40':
                sa=ShpstData.tubes[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

            ParamPipeShape.PipeShape(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='06':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='FB_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='FB'
            if st=='SS':
                sa=ShpstData.flat_ss[dia]
            elif st=='SUS':
                sa=ShpstData.flat_sus[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
           
            ParamFlatShape.FlatShape(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='07':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='LW_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='L'
            if st=='SS':
                sa=ShpstData.LW_angle_ss[dia]
            elif st=='SUS':
                sa=ShpstData.LW_angle_sus[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 
            
            ParamLWAngle.LWAngle(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 
        elif key=='08':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='CShape_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='C'
            if st=='SS':
                sa=ShpstData.LW_channel_ss[dia]
            elif st=='SUS':
                sa=ShpstData.LW_channel_sus[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

            ParamLWChannel.LWChannel(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='09':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            b='C'
            if st=='SS':
                sa=ShpstData.Rip_channel_ss[dia]
            elif st=='SUS':
                sa=ShpstData.Rip_channel_sus[dia]
            label='RipChannel_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

            ParamRipChannel.RipChannel(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

        elif key=='10':
            dia=self.comboBox_size.currentText()
            st=self.comboBox_st.currentText()
            label='SquarePipe_'+st
            obj = App.ActiveDocument.addObject("Part::FeaturePython",label)
            b='Square_Pipe'
            if st=='SS':
                sa=ShpstData.square_pipe_ss[dia]
            elif st=='SUS':
                sa=ShpstData.square_pipe_sus[dia]

            obj.addProperty("App::PropertyString", "L",label).L=L
            obj.addProperty("App::PropertyEnumeration", "size",label)
            obj.size=size
            i=self.comboBox_size.currentIndex()
            obj.size=size[i]
            st=self.comboBox_st.currentText()
            obj.addProperty("App::PropertyString", "standard",label).standard=st
            if self.checkbox.isChecked():
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = True 
            else:    
                obj.addProperty("App::PropertyBool", "Solid",label).Solid = False 

            ParamSqurePipe.SqurePipe(obj) 
            obj.ViewObject.Proxy=0
            FreeCAD.ActiveDocument.recompute() 

class main():
    d = QtGui.QWidget()
    d.ui = Ui_Dialog()
    d.ui.setupUi(d)
    d.show()
    
    







